(define-module (ui net-vlan ajax)
    :use-module (alterator str)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

(define (ui-read-iface name)
  (catch/message
	(lambda()
	  (form-update-enum "vlans_list" (woo-list "/net-vlan/iface_vlans"
											   'iface name
											   'language (form-value "language"))))))

(define (vlan-read)
  (let ((name (form-value "vlans_list")))
	(catch/message
	  (lambda()
		(form-update-value-list '("vlan_vid") (woo-read-first "/net-vlan"
															  'vlan_name name
															  'language (form-value "language"))))))
  (ui-update-activity))

(define (vlan-add)
  (catch/message
	(lambda()
	  (let* ((iface (form-value "iface"))
			 (vlan_name (woo-get-option
						  (woo-read-first "/net-vlan/new_vlan"
										  'iface iface
										  'vid (form-value "vlan_vid")
										  'language (form-value "language"))
						  'new_vlan)))
		(ui-read-iface iface)
		(form-update-value "vlans_list" vlan_name))))
  (ui-update-activity)
  (vlan-read))

(define (vlan-remove)
  (catch/message
	(lambda()
	  (woo-write "/net-vlan/rm_vlan" 'vlan_name (form-value "vlans_list") 'language (form-value "language"))))
  (ui-read-iface (form-value "iface"))
  (form-update-value "vlan_vid" "")
  (ui-update-activity))

(define (ui-update-activity)
  (let* ((n (form-value "vlans_list"))
		 (a (and (string? n)
				 (not (empty-string? n)))))
	(form-update-activity "remove_vlan" a)))

(define (ui-init name)
  (form-update-value "iface" name)
  (ui-read-iface name)
  (ui-update-activity))

(define (ui-exit)
  (form-replace (format #f "/net-eth?iface=~A" (form-value "iface"))))

; INIT
(define (init)
  (ui-init (form-value "iface"))
  (form-bind "back" "click" ui-exit)
  (form-bind "vlans_list"  "change" vlan-read)
  (form-bind "add_vlan" "click" vlan-add)
  (form-bind "remove_vlan" "click" vlan-remove))
